<?php

// this file calls functions only present in mgmnt.inc, and as such
// this require is not to be removed!
require_once "mgmnt.inc";

//<-----
//	$remote_database:	Array contains remote Z39.50-servers used to index data for
//						insertion into native MARC-database.
//						 The key is the info that will be displayed when performing the
//						search. The value is to be the _ENTIRE_ host-url of the server
//						of the form:
//
//						host[:port]/database
//----->

$remote_database = array(
						"Native" => $config['zebra_host'].":".$config['zebra_port']."/".$config['zebra_db'],
						"Libris" => "z3950.libris.kb.se:210/libr",
						"LOC" => "z3950.loc.gov:7090/voyager",
						);

//<-----
//	$YAZ_attributes:	Array used to replace the MARC-field numbers retrieved
//						when performing a search with the appropriate YAZ-attributes.
//----->

$YAZ_attributes = Array(
						"001" => "@attr 1=12",
						"020" => "@attr 1=7",
						"022" => "@attr 1=8",
						"100" => "@attr 1=1004",
						"245" => "@attr 1=4",
						"500" => "@attr 1=4",
						"852" => "@attr 1=1038",
						$remote_database['Libris'] => Array	(
															"001" => "@attr 1=1032",
															),
						);


function MARC_DataHand($parser, $data)
{
	global $MARC, $MARC_CurrField, $MARC_ParentField, $MARC_CurrFieldType;
	//print "[CURRTYPE: $MARC_CurrFieldType, CURR: $MARC_CurrField, DATA: $data]<br>";
	//print "[PARENT: $MARC_ParentField, CURR: $MARC_CurrField]<br>";

	if($MARC_CurrFieldType == "CONTROLFIELD" && $MARC_CurrField != "")
		$MARC[$MARC_CurrField] = $data;
	elseif($MARC_CurrFieldType != "DATAFIELD" && $MARC_CurrField != "")
		$MARC[$MARC_ParentField][$MARC_CurrField] = $data;

	$MARC_CurrField = "";
}

function MARC_StartElement($parser, $name, $params)
{
	global $MARC_CurrField, $MARC_ParentField, $MARC_CurrFieldType;

		$MARC_CurrFieldType = $name;

		if($MARC_CurrFieldType == "DATAFIELD") {
			$MARC_CurrField = $params['TAG'];
			$MARC_ParentField = $params['TAG'];
		}
		elseif($MARC_CurrFieldType == "CONTROLFIELD")
			$MARC_CurrField = $params['TAG'];
		elseif($MARC_CurrFieldType == "SUBFIELD")
			$MARC_CurrField = $params['CODE'];
}

function MARC_EndElement($parser, $name)
{
	//print "ELEMENT ENDED<br>";
	/*global $MARCAct, $PageID;
		//if ($name == $PageID || $name == "GENERAL")
			$MARCAct = 0;
	*/
}

function MARC_CheckEnd($parser, $name)
{
	// This function is just here to look pretty!
 	// However, PHP's XML parser needs this, so leave it alone!!
}

function parseMARC(&$data)
{
            global $MARC, $langText;
			$is_true = TRUE;
			$error = 0;
			$MARC = array();

			$xml_parser = xml_parser_create();
			xml_set_character_data_handler ( $xml_parser, "MARC_DataHand");
			xml_set_element_handler($xml_parser, "MARC_StartElement", "MARC_EndElement");

    		if (!xml_parse($xml_parser, $data, $is_true)) {
            	$error++;
			}

			xml_parser_free($xml_parser);
			return $error;
}

function createMARCRow($field_list_to_process)
{
	global 	$MARCsyn_config,
			$MARC_config,
			$MARC;

	$row = array();

	unset($key, $value);

	//while (list($key,$value) = each($MARCsyn_config)) Does not work, PHP bug?
	foreach ($field_list_to_process as $key => $value)
	{
		$field = "";
		$field_array = array();
		$syntax_array = array();

		if(!array_key_exists($key, $MARC_config))	//if the key is a valid field. If not, next value in foreach.
			continue;
		elseif(array_key_exists($key, $MARC)) {	//Checks if the key exists in the MARC data and if
        	$field = format_field($key, $value);
		}
		else				//If the code is not present in the $MARC-xml-data,
		{
			$field = "-";	//put an empty space there.
		}

			$row[$MARC_config[$key]] = $field;	//For easier accessing, store the fields with their appropriate names:
												//e.g. $row['book_isbn'] = 123456789
	}

	return $row;	//Return the data to the caller.
}

function format_field($field, $syntax)
{
 	global $MARC, $MARCsyn_config;
	$field_array = array();

	if($syntax == "all")
	{
		foreach($MARC[$field] as $_key => $_value) {				// all data is to be displayed.

			if(is_last_char($_value, rtrim($MARCsyn_config['all_separator']))) {		//If last char is same as separator
				$_value = chop_last($_value);											//chop off last char
				array_push($field_array, $_value, $MARCsyn_config['all_separator']);	//and replace with separator.
			}
			elseif(is_last_char($_value, "."))				//If last char is dot (.)
				array_push($field_array, $_value, " ");		//add space to next code,
			else
				array_push($field_array, $_value, $MARCsyn_config['all_separator']);	//otherwise add separator between codes.
		}
		if(end($field_array) == $MARCsyn_config['all_separator'])	//If the last index in array is separator
			array_pop($field_array);								//delete, since ending in comma is not very bright...=)

		$field = join("", $field_array);		//Merge the entire array into a string

		return strip_field($field);  //Return string.
	}
	else
	{
		$syntax_array = split("%", $syntax);		//split the formatting syntax.
		$popped = 0;

		foreach ($syntax_array as $syntax)
		{
			/*<-----
			MORE DOCUMENTATION:

			a string "%a, %d" is splitted at "%" into an array. Now the are of the form
			"a, " and "d". By matching the first digit in each array index, we get the code that
			is wanted. Then by replacing this "first digit" by the value from the $MARC-xml-data,
			we get a formatted syntax.
			 If the code represented by the firt digit is not present in the $MARC-xml-data it will
			not be inserted and as such we will get rid of all the formatting-text between the codes.
			----->*/
			if($syntax != "" && array_key_exists($syntax[0], $MARC[$field]))
			{
				array_push($field_array, $MARC[$field][$syntax[0]], pop_first($syntax));
				$popped = 0;
			}
			elseif(!$popped)
			{
				$new = preg_replace("/[^\)\]]/", "", end($field_array));
				array_pop($field_array);
				array_push($field_array, $new);
				$popped = 1;
			}

		}
		$field = join("", $field_array);	//MErge the entire array into a string.

		return strip_field($field);  //Return string.
	}
}

// Strip unappropriate strings from field-info
function strip_field($field)
{
	return preg_replace("/[;\/]/", " ", $field);  //Return string.
}


function createMARCRow_edit($field_list_to_process)
{
	global 	$MARC_config,
			$MARC;

	$row = array();
	unset($key, $value);

	foreach ($field_list_to_process as $value)
	{
		$field = substr($value,0,3);
		$code = substr($value,-1);

		if(is_numeric($code))
			continue;

		if(strlen($value) == 4 && array_key_exists($field, $MARC) && array_key_exists($code, $MARC[$field]))
			$row[$field][$code] = $MARC[$field][$code];
		else
			$row[$field][$code] = "";
		/*elseif(array_key_exists($key, $MARC) && !is_array($MARC[$key]))
			$row[$field] = $value;*/
	}

	return $row;

}

//<-----
// return_with_format_syntax:	Gets the format syntax of each field from the
//								MARCsyn_config-file, associates it with the appropriate
//								key and returns the array.
//----->

function return_with_format_syntax(&$list)
{
	global $MARCsyn_config;

	foreach ($list as $current_field)
				$field_list_to_process[$current_field]= $MARCsyn_config[$current_field];

	return $field_list_to_process;
}


//<-----
// book_control_number:	Greps and returns the "Control Number" (001) from the MARC-
//						record. If the "Control Number" is located i a subfield
//						(e.g. DANMARC) the value of the first subfield is returned.
//----->

function book_control_number()
{
	global $MARC;

	if(array_key_exists("001", $MARC)) {
		if(is_array($MARC["001"])) {
			while (list($key, $value) = each($MARC["001"])) {
				$book_control_number = $MARC["001"][$key];
				break;
			}
		}
		else
			$book_control_number = $MARC["001"];
	}
	else
		$book_control_number = "none";

	return preg_replace("/\s/", "", $book_control_number);
}

function verify_bookland(&$ean)
{
	$tmp = substr( strval($ean),0 ,3);
	return ($tmp == '978' || $tmp == '979');
}

//<-----
//	verify_ean:		Calculate the checksum of a Bookland EAN-code and verify that it
//					is correct. Checksums, weighting factors etc. are based on
//					information from http://www.bisg.org/booklanean.htm
//----->

function verify_ean($ean, $bookland = TRUE)
{
	$tmp = strval($ean);

	if(strlen($tmp) != 13 || strlen(preg_replace("/[^0-9]/", "", $tmp)) != 13) {
		return FALSE;
	}

	if ($bookland && !verify_bookland($ean)) {
		return FALSE;
	}

	$i = 0;
	$key = 1;
	$checksum = 0;

	while ($i < strlen($ean))
	{
		$checksum += $ean[$i] * $key;
		$key = ($key == 1) ? 3: 1;
		$i++;
	}

	return ($checksum % 10 == 0) ? TRUE : FALSE;
}

function verify_isbn($isbn)
{
	$sum = 0;
	$total_sum = 0;
	$tmp = strval($isbn);

	if (strlen($tmp) != 10) {
		return FALSE;
	}

	if ( strlen( preg_replace("/[^0-9]/", "", substr($tmp, 0, -1))) != 9) {
		return FALSE;
	}

	for ($i = 0; $i < strlen($isbn); $i++) {

		$digit = substr($isbn, $i, 1);

		if (strtoupper($digit) == 'X') {
			$digit = 10;
		}

		$sum += intval($digit);
		$total_sum += $sum;
	}

	return ($total_sum % 11 == 0) ? TRUE : FALSE;
}


//<-----
//	ean2isbn:	Calculate the correct ISBN-number from the Bookland EAN-code
//				Checksums, weighting factors etc. are based on information from
//				http://www.bisg.org/booklanean.htm
//----->

function ean2isbn(&$ean)
{
	$i = 10;
	$checksum = 0;

	$pre_isbn = substr($ean, 3, -1);

	while ($i >= 2)
	{
		$checksum += $i * $pre_isbn[10 - $i];
		$i--;
	}

	$check_digit = (11 - ($checksum % 11)) % 11;

	if($check_digit == 10)
		return $pre_isbn."X";
	else
		return $pre_isbn.$check_digit;
}

//<----
// format_isbn:		Strinps all unwanted characters from the ISBN. Especially
//					useful when retrieving data from remote Z39.50-servers.
//----->

function format_isbn(&$string)
{
	return preg_replace("/[^0-9X]/", "", $string);
}


//<-----
// is_valid_field:	Retruns true/false depending if the field supplied as argument
//					is a "valid" field. (Field that can be viewed in extended listing)
//----->

function is_valid_field ($field)
{
	return array_key_exists($field, $MARC_display_all);
}


function write_marc($_REQUEST_data)
{
	$perl_request = array();

	foreach ($_REQUEST_data as $key => $value)
	{
		if ($key == "id" || $key == "auth" || $key == "raw_marc")
			$perl_request[$key] = $value;
		elseif(is_valid_field($key))
			$perl_request[$key] = $value;
	}
}

function format_control_number($cn)
{
	global $MARCsyn_config;

	$length = strlen($cn);
	$zeros = "0";
	for($i=1;$i < ($MARCsyn_config['control_number_length'] - $length);$i++)
	{
		$zeros .= "0";
	}

	return $zeros.$cn;
}

function format_book_id($id)
{
	global $config, $MARCsyn_config;

	$length = strlen($id);
	$zeros = "0";
	for($i=1;$i < ($MARCsyn_config['book_id_length'] - $length);$i++)
	{
		$zeros .= "0";
	}
	return $zeros.$id.$config['book_id_suffix'];

}

function count_occurances($key, $string)
{
	$i = 0;

	$occurances = 0;
	while(strlen($string) > $i)
	{
		if($string[$i] == $key)
			$occurances++;

		$i++;
	}

    //print "<br>OCC: ".$occurances;
    return $occurances;
}

function boolify_query($query, $criteria = "", $url = "")
{
	global $YAZ_attributes;
	$formatted_query = array();

	if(strstr($query, "AND") || strstr($query, "OR") || strstr($query, "NOT"))
	{
		$words = split(" ", $query);
		$and = "";
		$rearranged = array();

		$word_count = count($words);
		while($word_count > 0)
		{
        	$word_count--;

			if($words[$word_count] == "AND"){
				if(array_key_exists(($word_count+1), $words) && array_key_exists(($word_count-1), $words)) {
					$and = "@and";
				}
				else {
					return "error bool";
				}
			}

			elseif($words[$word_count] == "OR"){
				if(array_key_exists(($word_count+1), $words) && array_key_exists(($word_count-1), $words)) {
                	$rearranged = array_merge(array("@or", $words[$word_count-1]), $rearranged);
					$word_count--;
				}
				else {
					return "error bool";
				}
			}
			elseif($words[$word_count] == "NOT"){
				if(array_key_exists(($word_count+1), $words) && array_key_exists(($word_count-1), $words)) {
                	$rearranged = array_merge(array("@not", $words[$word_count-1]), $rearranged);
					$word_count--;
				}
				else {
					return "error bool";
				}
			}
			else {
				$rearranged = array_merge(array($words[$word_count]), $rearranged);
			}
			//print $words[$word_count]."<br>";
			//print_r($rearranged);
		}

		if($and)
			$rearranged = array_merge(array($and), $rearranged);

		$formatted_query = $rearranged;
	}

	if(strstr($query, "*"))
	{
		//print "QUERY: ".$query;
		//print "<br>FORMATTED: ".join(" ",$formatted_query);

		if(!empty($formatted_query))
			$words = $formatted_query;
		else
			$words = split(" ", $query);

		if(count($words) == 1)
		{
			if(count_occurances("*", $words[0]) == 1 && is_last_char($words[0], "*")) {
				$words[0] = str_replace("*", "", $words[0]);  //Replace * with nothing
				$truncate = "@attr 5=1";  //Truncate right
				$word = $truncate." '".$words[0]."'";  //Create Yaz-syntax
			}
			elseif(count_occurances("*", $words[0]) == 1 && is_first_char($words[0], "*")) {
				$words[0] = str_replace("*", "", $words[0]);  //Replace * with nothing
				$truncate = "@attr 5=2";  //Truncate right
				$word = $truncate." '".$words[0]."'";  //Create Yaz-syntax
			}
			elseif(count_occurances("*", $words[0]) == 2) {
				$words[0] = str_replace("*", "", $words[0]);  //Replace * with nothing
				$truncate = "@attr 5=3";  //Truncate both left and right
				$word = $truncate." '".$words[0]."'";  //Create Yaz-syntax
			}
			else {
				$truncate = "@attr 5=100";  //Do not truncate
				$word = $truncate." '".$words[0]."'";  //Create Yaz-syntax
			}

			array_push($formatted_query, $word);
		}
		else
		{
            if(empty($formatted_query))
				array_push($formatted_query, "@and");
			else
				$formatted_query = array();

			print_r($words);

			foreach($words as $word)
			{
            	//print "WORD: ".$word;

				if(count_occurances("@", $word)) {
					// Do noting!
				}
				elseif(count_occurances("*", $word) == 1 && is_last_char($word, "*")) {
					$word = str_replace("*", "", $word);  //Replace * with nothing
					$truncate = "@attr 5=1";  //Truncate right
					$word = $truncate." ".$criteria." '".$word."'";  //Create Yaz-syntax
				}
				elseif(count_occurances("*", $word) == 1 && is_first_char($word, "*")) {
					$word = str_replace("*", "", $word);  //Replace * with nothing
					$truncate = "@attr 5=2";  //Truncate left
					$word = $truncate." ".$criteria." '".$word."'";  //Create Yaz-syntax
				}
				elseif(count_occurances("*", $word) == 2) {
					$word = str_replace("*", "", $word);  //Replace * with nothing
					$truncate = "@attr 5=3";  //Truncate both left and right
					$word = $truncate." ".$criteria." '".$word."'";  //Create Yaz-syntax
				}
				else {
					$truncate = "@attr 5=100";  //Do not truncate
					$word = $truncate." ".$criteria." '".$word."'";  //Create Yaz-syntax
				}

				array_push($formatted_query, $word);
			}

		}
	}

	if(!strstr($query, "*") && !strstr($query, "AND") && !strstr($query, "OR") && !strstr($query, "NOT")) {
		array_push($formatted_query, $query);
	}

	//print "QUERY: ".join(" ", $formatted_query);
    if($criteria == "") {
		return join(" ", $formatted_query);
	}
	else {
		if(array_key_exists($url, $YAZ_attributes) && array_key_exists($criteria, $YAZ_attributes[$url]))
		{
			if(!strstr($query, "*") && !strstr($query, "AND") && !strstr($query, "OR") && !strstr($query, "NOT")) {
				return $YAZ_attributes[$url][$criteria]." '".$query."'";
			}
			else
			{
				return $YAZ_attributes[$url][$criteria]." ".join(" ", $formatted_query);
			}
		}
		else
		{
			if(!strstr($query, "*") && !strstr($query, "AND") && !strstr($query, "OR") && !strstr($query, "NOT")) {
				return $YAZ_attributes[$criteria]." \"".$query."\"";
			}
			else
			{
				return $YAZ_attributes[$criteria]." ".join(" ", $formatted_query);
			}
		}
	}
}

?>
